type AllowNull<T, B extends boolean> = B extends true ? T | null : T;
export declare const chainItem: <C extends readonly ("Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky")[] = ["Solana", "Ethereum", "Terra", "Bsc", "Polygon", "Avalanche", "Oasis", "Algorand", "Aurora", "Fantom", "Karura", "Acala", "Klaytn", "Celo", "Near", "Moonbeam", "Neon", "Terra2", "Injective", "Osmosis", "Sui", "Aptos", "Arbitrum", "Optimism", "Gnosis", "Pythnet", "Xpla", "Btc", "Base", "Sei", "Rootstock", "Wormchain", "Cosmoshub", "Evmos", "Kujira", "Sepolia", "ArbitrumSepolia", "BaseSepolia", "OptimismSepolia", "Holesky"], N extends boolean = false>(opts?: {
    allowedChains?: C | undefined;
    allowNull?: N | undefined;
} | undefined) => {
    readonly custom: {
        to: (val: number) => AllowNull<C[number], N>;
        from: (val: AllowNull<C[number], N>) => number;
    };
    readonly binary: "uint";
    readonly size: 2;
};
export declare const fixedChainItem: <C extends "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky">(chain: C) => {
    readonly custom: {
        to: C;
        from: (C extends bigint ? `bigint(${C})` : C extends boolean ? `boolean(${C})` : C) extends "Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky" ? {
            readonly Solana: 1;
            readonly Ethereum: 2;
            readonly Terra: 3;
            readonly Bsc: 4;
            readonly Polygon: 5;
            readonly Avalanche: 6;
            readonly Oasis: 7;
            readonly Algorand: 8;
            readonly Aurora: 9;
            readonly Fantom: 10;
            readonly Karura: 11;
            readonly Acala: 12;
            readonly Klaytn: 13;
            readonly Celo: 14;
            readonly Near: 15;
            readonly Moonbeam: 16;
            readonly Neon: 17;
            readonly Terra2: 18;
            readonly Injective: 19;
            readonly Osmosis: 20;
            readonly Sui: 21;
            readonly Aptos: 22;
            readonly Arbitrum: 23;
            readonly Optimism: 24;
            readonly Gnosis: 25;
            readonly Pythnet: 26;
            readonly Xpla: 28;
            readonly Btc: 29;
            readonly Base: 30;
            readonly Sei: 32;
            readonly Rootstock: 33;
            readonly Wormchain: 3104;
            readonly Cosmoshub: 4000;
            readonly Evmos: 4001;
            readonly Kujira: 4002;
            readonly Sepolia: 10002;
            readonly ArbitrumSepolia: 10003;
            readonly BaseSepolia: 10004;
            readonly OptimismSepolia: 10005;
            readonly Holesky: 10006;
        }[("Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky") & (C extends bigint ? `bigint(${C})` : C extends boolean ? `boolean(${C})` : C)] extends {
            [key: string]: unknown;
            [key: number]: unknown;
            [key: symbol]: unknown;
        } ? {
            readonly Solana: 1;
            readonly Ethereum: 2;
            readonly Terra: 3;
            readonly Bsc: 4;
            readonly Polygon: 5;
            readonly Avalanche: 6;
            readonly Oasis: 7;
            readonly Algorand: 8;
            readonly Aurora: 9;
            readonly Fantom: 10;
            readonly Karura: 11;
            readonly Acala: 12;
            readonly Klaytn: 13;
            readonly Celo: 14;
            readonly Near: 15;
            readonly Moonbeam: 16;
            readonly Neon: 17;
            readonly Terra2: 18;
            readonly Injective: 19;
            readonly Osmosis: 20;
            readonly Sui: 21;
            readonly Aptos: 22;
            readonly Arbitrum: 23;
            readonly Optimism: 24;
            readonly Gnosis: 25;
            readonly Pythnet: 26;
            readonly Xpla: 28;
            readonly Btc: 29;
            readonly Base: 30;
            readonly Sei: 32;
            readonly Rootstock: 33;
            readonly Wormchain: 3104;
            readonly Cosmoshub: 4000;
            readonly Evmos: 4001;
            readonly Kujira: 4002;
            readonly Sepolia: 10002;
            readonly ArbitrumSepolia: 10003;
            readonly BaseSepolia: 10004;
            readonly OptimismSepolia: 10005;
            readonly Holesky: 10006;
        }[("Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky") & (C extends bigint ? `bigint(${C})` : C extends boolean ? `boolean(${C})` : C)] : {
            readonly Solana: 1;
            readonly Ethereum: 2;
            readonly Terra: 3;
            readonly Bsc: 4;
            readonly Polygon: 5;
            readonly Avalanche: 6;
            readonly Oasis: 7;
            readonly Algorand: 8;
            readonly Aurora: 9;
            readonly Fantom: 10;
            readonly Karura: 11;
            readonly Acala: 12;
            readonly Klaytn: 13;
            readonly Celo: 14;
            readonly Near: 15;
            readonly Moonbeam: 16;
            readonly Neon: 17;
            readonly Terra2: 18;
            readonly Injective: 19;
            readonly Osmosis: 20;
            readonly Sui: 21;
            readonly Aptos: 22;
            readonly Arbitrum: 23;
            readonly Optimism: 24;
            readonly Gnosis: 25;
            readonly Pythnet: 26;
            readonly Xpla: 28;
            readonly Btc: 29;
            readonly Base: 30;
            readonly Sei: 32;
            readonly Rootstock: 33;
            readonly Wormchain: 3104;
            readonly Cosmoshub: 4000;
            readonly Evmos: 4001;
            readonly Kujira: 4002;
            readonly Sepolia: 10002;
            readonly ArbitrumSepolia: 10003;
            readonly BaseSepolia: 10004;
            readonly OptimismSepolia: 10005;
            readonly Holesky: 10006;
        }[("Solana" | "Btc" | "Algorand" | "Sui" | "Aptos" | "Near" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky") & (C extends bigint ? `bigint(${C})` : C extends boolean ? `boolean(${C})` : C)] : never;
    };
    readonly binary: "uint";
    readonly size: 2;
};
export {};
//# sourceMappingURL=chain.d.ts.map