"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixedChainItem = exports.chainItem = void 0;
const sdk_base_1 = require("@wormhole-foundation/sdk-base");
const chainItemBase = { binary: "uint", size: 2 };
const chainItem = (opts) => ({
    ...chainItemBase,
    custom: {
        to: (val) => {
            if (val === 0) {
                if (!opts?.allowNull)
                    throw new Error("ChainId 0 is not valid for this protocol and action");
                return null;
            }
            const chain = (0, sdk_base_1.chainIdToChain)((0, sdk_base_1.toChainId)(val));
            const allowedChains = opts?.allowedChains ?? sdk_base_1.chains;
            if (!allowedChains.includes(chain))
                throw new Error(`Chain ${chain} not in allowed chains ${allowedChains}`);
            return chain;
        },
        from: (val) => val == null ? 0 : (0, sdk_base_1.chainToChainId)(val),
    },
});
exports.chainItem = chainItem;
const fixedChainItem = (chain) => ({
    ...chainItemBase,
    custom: {
        to: chain,
        from: (0, sdk_base_1.chainToChainId)(chain),
    },
});
exports.fixedChainItem = fixedChainItem;
//# sourceMappingURL=chain.js.map