"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.signatureItem = void 0;
const sdk_base_1 = require("@wormhole-foundation/sdk-base");
const signature_1 = require("../signature");
const signatureLayout = [
    { name: "r", binary: "uint", size: 32 },
    { name: "s", binary: "uint", size: 32 },
    { name: "v", binary: "uint", size: 1 },
];
exports.signatureItem = {
    binary: "bytes",
    size: 65,
    custom: {
        to: (val) => {
            const sig = (0, sdk_base_1.deserializeLayout)(signatureLayout, val);
            return new signature_1.Signature(sig.r, sig.s, sig.v);
        },
        from: (val) => (0, sdk_base_1.serializeLayout)(signatureLayout, { r: val.r, s: val.s, v: val.v }),
    },
};
//# sourceMappingURL=signature.js.map