import { Chain, Network, Platform, PlatformToChains, ProtocolName } from "@wormhole-foundation/sdk-base";
import { ChainContext, ChainsConfig, PlatformContext, PlatformUtils, RpcConnection, TokenAddress, TokenId } from "../..";
export declare function mockPlatformFactory<N extends Network, P extends Platform>(platform: P, config: ChainsConfig<N, P>): PlatformUtils<N, P>;
export declare class MockPlatform<N extends Network, P extends Platform> extends PlatformContext<N, P> {
    constructor(network: N, config: ChainsConfig<N, P>);
    static getProtocol<PN extends ProtocolName, T extends any>(protocol: PN): T;
    getChain<C extends Chain>(chain: C): ChainContext<N, P, C>;
    getRpc<C extends PlatformToChains<P>>(chain: C): RpcConnection<P>;
    getWrappedAsset<C extends PlatformToChains<P>>(chain: C, rpc: RpcConnection<P>, token: TokenId<C>): Promise<TokenId<C> | null>;
    getTokenDecimals(rpc: RpcConnection<P>, token: TokenId<PlatformToChains<P>>): Promise<bigint>;
    getNativeBalance(rpc: RpcConnection<P>, walletAddr: string): Promise<bigint>;
    getDecimals<C extends PlatformToChains<P>>(chain: C, rpc: RpcConnection<P>, token: TokenAddress<C>): Promise<number>;
}
//# sourceMappingURL=platform.d.ts.map