"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerPayloadTypes = exports.registerPayloadType = exports.payloadFactory = exports.composeLiteral = void 0;
const composeLiteral = (protocol, payloadName) => (protocol ? `${protocol}:${payloadName}` : payloadName);
exports.composeLiteral = composeLiteral;
exports.payloadFactory = new Map();
function registerPayloadType(protocol, name, layout) {
    const payloadLiteral = (0, exports.composeLiteral)(protocol, name);
    if (exports.payloadFactory.has(payloadLiteral))
        throw new Error(`Payload type ${payloadLiteral} already registered`);
    exports.payloadFactory.set(payloadLiteral, layout);
}
exports.registerPayloadType = registerPayloadType;
function registerPayloadTypes(protocol, payloads) {
    for (const [name, layout] of payloads)
        registerPayloadType(protocol, name, layout);
}
exports.registerPayloadTypes = registerPayloadTypes;
//# sourceMappingURL=registration.js.map