"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.baseLayout = exports.envelopeLayout = exports.headerLayout = exports.decomposeLiteral = void 0;
const layout_items_1 = require("../layout-items");
function decomposeLiteral(payloadLiteral) {
    const index = payloadLiteral.indexOf(":");
    return (index !== -1
        ? [payloadLiteral.slice(0, index), payloadLiteral.slice(index + 1)]
        : [null, payloadLiteral]);
}
exports.decomposeLiteral = decomposeLiteral;
const guardianSignatureLayout = [
    { name: "guardianIndex", binary: "uint", size: 1 },
    { name: "signature", ...layout_items_1.signatureItem },
];
exports.headerLayout = [
    { name: "version", binary: "uint", size: 1, custom: 1, omit: true },
    { name: "guardianSet", ...layout_items_1.guardianSetItem },
    { name: "signatures", binary: "array", lengthSize: 1, layout: guardianSignatureLayout },
];
//envelope + payload are getting hashed and signed
exports.envelopeLayout = [
    { name: "timestamp", binary: "uint", size: 4 },
    { name: "nonce", binary: "uint", size: 4 },
    { name: "emitterChain", ...(0, layout_items_1.chainItem)() },
    { name: "emitterAddress", ...layout_items_1.universalAddressItem },
    { name: "sequence", ...layout_items_1.sequenceItem },
    { name: "consistencyLevel", binary: "uint", size: 1 },
];
exports.baseLayout = [...exports.headerLayout, ...exports.envelopeLayout];
//# sourceMappingURL=vaa.js.map