import { serializeLayout, deserializeLayout, } from "@wormhole-foundation/sdk-base";
import { Signature } from "../signature";
const signatureLayout = [
    { name: "r", binary: "uint", size: 32 },
    { name: "s", binary: "uint", size: 32 },
    { name: "v", binary: "uint", size: 1 },
];
export const signatureItem = {
    binary: "bytes",
    size: 65,
    custom: {
        to: (val) => {
            const sig = deserializeLayout(signatureLayout, val);
            return new Signature(sig.r, sig.s, sig.v);
        },
        from: (val) => serializeLayout(signatureLayout, { r: val.r, s: val.s, v: val.v }),
    },
};
//# sourceMappingURL=signature.js.map