"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.namedPayloads = exports.connectPayload = void 0;
const layout_items_1 = require("../layout-items");
const vaa_1 = require("../vaa");
const tokenBridge_1 = require("./tokenBridge");
//from here:
// https://github.com/wormhole-foundation/example-token-bridge-relayer/blob/1a04ec51f4cfded04e59160bcf2e64aa29dea1f3/evm/src/token-bridge-relayer/TokenBridgeRelayer.sol#L260-L267
exports.connectPayload = [
    (0, layout_items_1.payloadIdItem)(1),
    { name: "targetRelayerFee", ...layout_items_1.amountItem },
    { name: "toNativeTokenAmount", ...layout_items_1.amountItem },
    { name: "targetRecipient", ...layout_items_1.universalAddressItem },
];
exports.namedPayloads = [
    ["TransferWithRelay", (0, tokenBridge_1.transferWithPayloadLayout)({ binary: "object", layout: exports.connectPayload })],
];
(0, vaa_1.registerPayloadTypes)("AutomaticTokenBridge", exports.namedPayloads);
//# sourceMappingURL=automaticTokenBridge.js.map