import "./automaticCircleBridge";
import { RegisterPayloadTypes } from "../vaa";
export declare const circleMessageLayout: readonly [{
    readonly binary: "uint";
    readonly size: 4;
    readonly custom: 0;
    readonly omit: true;
    readonly name: "version";
}, {
    readonly binary: "uint";
    readonly size: 4;
    readonly custom: {
        to: (id: number) => "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base";
        from: (name: "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base") => 0 | 1 | 2 | 3 | 5 | 6;
    };
    readonly name: "sourceDomain";
}, {
    readonly binary: "uint";
    readonly size: 4;
    readonly custom: {
        to: (id: number) => "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base";
        from: (name: "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base") => 0 | 1 | 2 | 3 | 5 | 6;
    };
    readonly name: "destinationDomain";
}, {
    readonly binary: "uint";
    readonly size: 8;
    readonly name: "nonce";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "sender";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "recipient";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "destinationCaller";
}, {
    readonly name: "payload";
    readonly binary: "object";
    readonly layout: readonly [{
        readonly binary: "uint";
        readonly size: 4;
        readonly custom: 0;
        readonly omit: true;
        readonly name: "messageBodyVersion";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "burnToken";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "mintRecipient";
    }, {
        readonly binary: "uint";
        readonly size: 32;
        readonly name: "amount";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "messageSender";
    }];
}];
export declare const namedPayloads: readonly [readonly ["Message", readonly [{
    readonly binary: "uint";
    readonly size: 4;
    readonly custom: 0;
    readonly omit: true;
    readonly name: "version";
}, {
    readonly binary: "uint";
    readonly size: 4;
    readonly custom: {
        to: (id: number) => "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base";
        from: (name: "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base") => 0 | 1 | 2 | 3 | 5 | 6;
    };
    readonly name: "sourceDomain";
}, {
    readonly binary: "uint";
    readonly size: 4;
    readonly custom: {
        to: (id: number) => "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base";
        from: (name: "Solana" | "Ethereum" | "Avalanche" | "Arbitrum" | "Optimism" | "Base") => 0 | 1 | 2 | 3 | 5 | 6;
    };
    readonly name: "destinationDomain";
}, {
    readonly binary: "uint";
    readonly size: 8;
    readonly name: "nonce";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "sender";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "recipient";
}, {
    readonly binary: "bytes";
    readonly size: 32;
    readonly custom: {
        to: (val: Uint8Array) => import("..").UniversalAddress;
        from: (val: import("..").UniversalAddress) => Uint8Array;
    };
    readonly name: "destinationCaller";
}, {
    readonly name: "payload";
    readonly binary: "object";
    readonly layout: readonly [{
        readonly binary: "uint";
        readonly size: 4;
        readonly custom: 0;
        readonly omit: true;
        readonly name: "messageBodyVersion";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "burnToken";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "mintRecipient";
    }, {
        readonly binary: "uint";
        readonly size: 32;
        readonly name: "amount";
    }, {
        readonly binary: "bytes";
        readonly size: 32;
        readonly custom: {
            to: (val: Uint8Array) => import("..").UniversalAddress;
            from: (val: import("..").UniversalAddress) => Uint8Array;
        };
        readonly name: "messageSender";
    }];
}]]];
declare global {
    namespace WormholeNamespace {
        interface PayloadLiteralToLayoutMapping extends RegisterPayloadTypes<"CircleBridge", typeof namedPayloads> {
        }
    }
}
//# sourceMappingURL=circleBridge.d.ts.map